/*******************************************************************************
				Neoinput
				========

		Copyright (C) 2010 Paul Kocialkowski

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include <unistd.h>
#include <fcntl.h>

#include <string.h>

/* TODO : Ajouter un élément touch_speed */
char *server_config_array[][3]={
{"ip",			NULL,			NULL},
{"port",		"3334", 		NULL},
{"device_touch",	"/dev/input/event1", 	NULL},
{"device_accel",	"/dev/input/event2",	NULL},
{"device_button_aux",	"/dev/input/event4",	NULL},
{"device_button_power",	"/dev/input/event0",	NULL},
};

char *server_config_value_get(char *arg)
{
	int i;
	int server_config_array_index=sizeof(server_config_array) / (sizeof(char *) * 3);

	for(i=0 ; i < server_config_array_index ; i++)
		if(strcmp(arg, server_config_array[i][0]) == 0)
			if(server_config_array[i][2] != NULL)
				return server_config_array[i][2];
			else
				return server_config_array[i][1];

	printf("Error: wrong config argument: '%s'.\n", arg);

	return NULL;
}

void server_config_value_set(char *arg, char *val)
{
	int i;
	int server_config_array_index=sizeof(server_config_array) / (sizeof(char *) * 3);

	for(i=0 ; i < server_config_array_index ; i++)
		if(strcmp(arg, server_config_array[i][0]) == 0)
		{
			server_config_array[i][2]=val;
			printf("Config: %s=%s\n", arg, val);
			return;
		}

	printf("Error: wrong config argument: '%s'.\n", arg);
	free(val);
}

void server_config_close()
{
	int i;
	int server_config_array_index=sizeof(server_config_array) / (sizeof(char *) * 3);

	for(i=0 ; i < server_config_array_index ; i++)
		free(server_config_array[i][2]);
}

void server_config_read(char *server_config_file)
{
	int server_config_fd=0;

	char c=0;
	char *arg=NULL;
	char *val=NULL;

	bool arg_lock=true;
	bool val_lock=true;
	bool comment_lock=false;

	int arg_count=0;
	int val_count=0;

	server_config_fd=open(server_config_file, O_RDONLY);
	if(server_config_fd < 0)
	{
		perror("Error while opening config file");
		exit(1);
	}

	arg=malloc(256);
	memset(arg, 0, 256);

	val=malloc(256);
	memset(val, 0, 256);

	while(read(server_config_fd, &c, sizeof(char)))
	{
		if(c == '\n')
		{
			comment_lock=false;

			if(strcmp(arg, "") == 0 || strcmp(val, "") == 0)
				continue;

			server_config_value_set(arg, val);

			memset(arg, 0, 256);
			val=malloc(256);
			memset(val, 0, 256);

			arg_lock=true;
			val_lock=true;

			arg_count=0;
			val_count=0;

			continue;
		}
		if(c == '#')
		{
			comment_lock=true;
			continue;
		}
		if(comment_lock)
			continue;
		if(c == '=')
		{
			arg_lock=false;
			continue;
		}
		if((c == ' ' || c == '\t') && (arg_lock || val_lock) || c == '"' || c == '\'')
			continue;
	
		if(arg_lock)
		{
			arg[arg_count]=c;
			arg_count++;
		}
		else
		{
			if(val_lock)
				val_lock=false;

			val[val_count]=c;
			val_count++;
		}
	}

	close(server_config_fd);
}

